org.glassfish.jersey.server.filter

## Class UriConnegFilter

- java.lang.Object
- - org.glassfish.jersey.server.filter.UriConnegFilter

All Implemented Interfaces:
  jakarta.ws.rs.container.ContainerRequestFilter

    @PreMatching
     @Priority(value=3000)
    public final class UriConnegFilter
    extends Object
    implements jakarta.ws.rs.container.ContainerRequestFilter

A URI-based content negotiation filter mapping a dot-declared suffix in URI to media type that is the value of the `Accept` header or a language that is the value of the `Accept-Language` header.

This filter may be used when the acceptable media type and acceptable language need to be declared in the URI.

This class may be extended to declare the mappings and the extending class, `foo.MyUriConnegFilter` say, can be registered as a container request filter.

If a suffix of "atom" is registered with a media type of "application/atom+xml" then a GET request of:

    GET /resource.atom

is transformed to:

    GET /resource
     Accept: application/atom+xml

Any existing "Accept" header value will be replaced.

If a suffix of "english" is registered with a language of "en" then a GET request of:

    GET /resource.english

is transformed to:

    GET /resource
     Accept-Language: en

Any existing "Accept-Language"header value will be replaced.

The media type mappings are processed before the language type mappings.

Author:
  Paul Sandoz, Martin Matula

### Field Summary

Fields
`protected Map<String,String>` `languageMappings`
`protected Map<String,jakarta.ws.rs.core.MediaType>` `mediaTypeMappings`

### Constructor Summary

Constructors
Constructor and Description
`UriConnegFilter(jakarta.ws.rs.core.Configuration rc)` Create a filter that reads the configuration (media type and language mappings) from the provided `ResourceConfig` instance.
`UriConnegFilter(Map<String,jakarta.ws.rs.core.MediaType> mediaTypeMappings, Map<String,String> languageMappings)` Create a filter with suffix to media type mappings and suffix to language mappings.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `filter(jakarta.ws.rs.container.ContainerRequestContext rc)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### mediaTypeMappings

    protected final Map<String,jakarta.ws.rs.core.MediaType> mediaTypeMappings

#### languageMappings

    protected final Map<String,String> languageMappings

### Constructor Detail

#### UriConnegFilter

    public UriConnegFilter(@Context
                           jakarta.ws.rs.core.Configuration rc)

Create a filter that reads the configuration (media type and language mappings) from the provided `ResourceConfig` instance. This constructor will be called by the Jersey runtime when the filter class is returned from `Application.getClasses()`. The `ResourceConfig` instance will get auto-injected.

Parameters:
  `rc` - ResourceConfig instance that holds the configuration for the filter.

#### UriConnegFilter

    public UriConnegFilter(Map<String,jakarta.ws.rs.core.MediaType> mediaTypeMappings,
                           Map<String,String> languageMappings)

Create a filter with suffix to media type mappings and suffix to language mappings.

Parameters:
  `mediaTypeMappings` - the suffix to media type mappings.
  `languageMappings` - the suffix to language mappings.

### Method Detail

#### filter

    public void filter(jakarta.ws.rs.container.ContainerRequestContext rc)
                throws IOException

Specified by:
  `filter` in interface `jakarta.ws.rs.container.ContainerRequestFilter`
Throws:
  `IOException`